Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/generic/src/mm/as.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -80,8 +80,4 @@
 #include <arch/interrupt.h>
 
-#ifdef CONFIG_VIRT_IDX_DCACHE
-#include <arch/mm/cache.h>
-#endif /* CONFIG_VIRT_IDX_DCACHE */
-
 /**
  * Each architecture decides what functions will be used to carry out
@@ -98,5 +94,5 @@
  *
  * This lock protects:
- * - inactive_as_with_asid_head list
+ * - inactive_as_with_asid_list
  * - as->asid for each as of the as_t type
  * - asids_allocated counter
@@ -109,5 +105,5 @@
  * that have valid ASID.
  */
-LIST_INITIALIZE(inactive_as_with_asid_head);
+LIST_INITIALIZE(inactive_as_with_asid_list);
 
 /** Kernel address space. */
@@ -239,8 +235,8 @@
 	bool cond = true;
 	while (cond) {
-		ASSERT(!list_empty(&as->as_area_btree.leaf_head));
+		ASSERT(!list_empty(&as->as_area_btree.leaf_list));
 		
 		btree_node_t *node =
-		    list_get_instance(as->as_area_btree.leaf_head.next,
+		    list_get_instance(list_first(&as->as_area_btree.leaf_list),
 		    btree_node_t, leaf_link);
 		
@@ -306,5 +302,5 @@
 	 * We don't want any area to have conflicts with NULL page.
 	 */
-	if (overlaps(addr, count << PAGE_WIDTH, (uintptr_t) NULL, PAGE_SIZE))
+	if (overlaps(addr, P2SZ(count), (uintptr_t) NULL, PAGE_SIZE))
 		return false;
 	
@@ -333,6 +329,6 @@
 			mutex_lock(&area->lock);
 			
-			if (overlaps(addr, count << PAGE_WIDTH,
-			    area->base, area->pages << PAGE_WIDTH)) {
+			if (overlaps(addr, P2SZ(count), area->base,
+			    P2SZ(area->pages))) {
 				mutex_unlock(&area->lock);
 				return false;
@@ -350,6 +346,6 @@
 			mutex_lock(&area->lock);
 			
-			if (overlaps(addr, count << PAGE_WIDTH,
-			    area->base, area->pages << PAGE_WIDTH)) {
+			if (overlaps(addr, P2SZ(count), area->base,
+			    P2SZ(area->pages))) {
 				mutex_unlock(&area->lock);
 				return false;
@@ -370,6 +366,6 @@
 		mutex_lock(&area->lock);
 		
-		if (overlaps(addr, count << PAGE_WIDTH,
-		    area->base, area->pages << PAGE_WIDTH)) {
+		if (overlaps(addr, P2SZ(count), area->base,
+		    P2SZ(area->pages))) {
 			mutex_unlock(&area->lock);
 			return false;
@@ -384,6 +380,5 @@
 	 */
 	if (!KERNEL_ADDRESS_SPACE_SHADOWED) {
-		return !overlaps(addr, count << PAGE_WIDTH,
-		    KERNEL_ADDRESS_SPACE_START,
+		return !overlaps(addr, P2SZ(count), KERNEL_ADDRESS_SPACE_START,
 		    KERNEL_ADDRESS_SPACE_END - KERNEL_ADDRESS_SPACE_START);
 	}
@@ -448,4 +443,12 @@
 		memsetb(&area->backend_data, sizeof(area->backend_data), 0);
 	
+	if (area->backend && area->backend->create) {
+		if (!area->backend->create(area)) {
+			free(area);
+			mutex_unlock(&as->lock);
+			return NULL;
+		}
+	}
+	
 	btree_create(&area->used_space);
 	btree_insert(&as->as_area_btree, base, (void *) area, NULL);
@@ -470,5 +473,6 @@
 	
 	btree_node_t *leaf;
-	as_area_t *area = (as_area_t *) btree_search(&as->as_area_btree, va, &leaf);
+	as_area_t *area = (as_area_t *) btree_search(&as->as_area_btree, va,
+	    &leaf);
 	if (area) {
 		/* va is the base address of an address space area */
@@ -478,5 +482,5 @@
 	
 	/*
-	 * Search the leaf node and the righmost record of its left neighbour
+	 * Search the leaf node and the rightmost record of its left neighbour
 	 * to find out whether this is a miss or va belongs to an address
 	 * space area found there.
@@ -490,7 +494,7 @@
 		
 		mutex_lock(&area->lock);
-		
+
 		if ((area->base <= va) &&
-		    (va < area->base + (area->pages << PAGE_WIDTH)))
+		    (va <= area->base + (P2SZ(area->pages) - 1)))
 			return area;
 		
@@ -502,5 +506,6 @@
 	 * Because of its position in the B+tree, it must have base < va.
 	 */
-	btree_node_t *lnode = btree_leaf_node_left_neighbour(&as->as_area_btree, leaf);
+	btree_node_t *lnode = btree_leaf_node_left_neighbour(&as->as_area_btree,
+	    leaf);
 	if (lnode) {
 		area = (as_area_t *) lnode->value[lnode->keys - 1];
@@ -508,5 +513,5 @@
 		mutex_lock(&area->lock);
 		
-		if (va < area->base + (area->pages << PAGE_WIDTH))
+		if (va <= area->base + (P2SZ(area->pages) - 1))
 			return area;
 		
@@ -573,5 +578,5 @@
 	
 	if (pages < area->pages) {
-		uintptr_t start_free = area->base + (pages << PAGE_WIDTH);
+		uintptr_t start_free = area->base + P2SZ(pages);
 		
 		/*
@@ -586,5 +591,5 @@
 		 */
 		ipl_t ipl = tlb_shootdown_start(TLB_INVL_PAGES, as->asid,
-		    area->base + (pages << PAGE_WIDTH), area->pages - pages);
+		    area->base + P2SZ(pages), area->pages - pages);
 		
 		/*
@@ -597,8 +602,8 @@
 		bool cond = true;
 		while (cond) {
-			ASSERT(!list_empty(&area->used_space.leaf_head));
+			ASSERT(!list_empty(&area->used_space.leaf_list));
 			
 			btree_node_t *node =
-			    list_get_instance(area->used_space.leaf_head.prev,
+			    list_get_instance(list_last(&area->used_space.leaf_list),
 			    btree_node_t, leaf_link);
 			
@@ -609,8 +614,8 @@
 				size_t i = 0;
 				
-				if (overlaps(ptr, size << PAGE_WIDTH, area->base,
-				    pages << PAGE_WIDTH)) {
+				if (overlaps(ptr, P2SZ(size), area->base,
+				    P2SZ(pages))) {
 					
-					if (ptr + (size << PAGE_WIDTH) <= start_free) {
+					if (ptr + P2SZ(size) <= start_free) {
 						/*
 						 * The whole interval fits
@@ -643,6 +648,6 @@
 				
 				for (; i < size; i++) {
-					pte_t *pte = page_mapping_find(as, ptr +
-					    (i << PAGE_WIDTH));
+					pte_t *pte = page_mapping_find(as,
+					    ptr + P2SZ(i), false);
 					
 					ASSERT(pte);
@@ -653,10 +658,9 @@
 					    (area->backend->frame_free)) {
 						area->backend->frame_free(area,
-						    ptr + (i << PAGE_WIDTH),
+						    ptr + P2SZ(i),
 						    PTE_GET_FRAME(pte));
 					}
 					
-					page_mapping_remove(as, ptr +
-					    (i << PAGE_WIDTH));
+					page_mapping_remove(as, ptr + P2SZ(i));
 				}
 			}
@@ -667,12 +671,13 @@
 		 */
 		
-		tlb_invalidate_pages(as->asid, area->base + (pages << PAGE_WIDTH),
+		tlb_invalidate_pages(as->asid, area->base + P2SZ(pages),
 		    area->pages - pages);
 		
 		/*
-		 * Invalidate software translation caches (e.g. TSB on sparc64).
-		 */
-		as_invalidate_translation_cache(as, area->base +
-		    (pages << PAGE_WIDTH), area->pages - pages);
+		 * Invalidate software translation caches
+		 * (e.g. TSB on sparc64, PHT on ppc32).
+		 */
+		as_invalidate_translation_cache(as, area->base + P2SZ(pages),
+		    area->pages - pages);
 		tlb_shootdown_finalize(ipl);
 		
@@ -690,4 +695,12 @@
 	}
 	
+	if (area->backend && area->backend->resize) {
+		if (!area->backend->resize(area, pages)) {
+			mutex_unlock(&area->lock);
+			mutex_unlock(&as->lock);
+			return ENOMEM;
+		}
+	}
+	
 	area->pages = pages;
 	
@@ -714,5 +727,4 @@
 	if (--sh_info->refcount == 0) {
 		dealloc = true;
-		link_t *cur;
 		
 		/*
@@ -720,6 +732,5 @@
 		 * reference from all frames found there.
 		 */
-		for (cur = sh_info->pagemap.leaf_head.next;
-		    cur != &sh_info->pagemap.leaf_head; cur = cur->next) {
+		list_foreach(sh_info->pagemap.leaf_list, cur) {
 			btree_node_t *node
 			    = list_get_instance(cur, btree_node_t, leaf_link);
@@ -756,4 +767,7 @@
 		return ENOENT;
 	}
+
+	if (area->backend && area->backend->destroy)
+		area->backend->destroy(area);
 	
 	uintptr_t base = area->base;
@@ -770,7 +784,5 @@
 	 * Visit only the pages mapped by used_space B+tree.
 	 */
-	link_t *cur;
-	for (cur = area->used_space.leaf_head.next;
-	    cur != &area->used_space.leaf_head; cur = cur->next) {
+	list_foreach(area->used_space.leaf_list, cur) {
 		btree_node_t *node;
 		btree_key_t i;
@@ -782,6 +794,6 @@
 			
 			for (size = 0; size < (size_t) node->value[i]; size++) {
-				pte_t *pte =
-				    page_mapping_find(as, ptr + (size << PAGE_WIDTH));
+				pte_t *pte = page_mapping_find(as,
+				     ptr + P2SZ(size), false);
 				
 				ASSERT(pte);
@@ -792,8 +804,9 @@
 				    (area->backend->frame_free)) {
 					area->backend->frame_free(area,
-					    ptr + (size << PAGE_WIDTH), PTE_GET_FRAME(pte));
+					    ptr + P2SZ(size),
+					    PTE_GET_FRAME(pte));
 				}
 				
-				page_mapping_remove(as, ptr + (size << PAGE_WIDTH));
+				page_mapping_remove(as, ptr + P2SZ(size));
 			}
 		}
@@ -807,6 +820,6 @@
 	
 	/*
-	 * Invalidate potential software translation caches (e.g. TSB on
-	 * sparc64).
+	 * Invalidate potential software translation caches
+	 * (e.g. TSB on sparc64, PHT on ppc32).
 	 */
 	as_invalidate_translation_cache(as, area->base, area->pages);
@@ -882,5 +895,5 @@
 	}
 	
-	size_t src_size = src_area->pages << PAGE_WIDTH;
+	size_t src_size = P2SZ(src_area->pages);
 	unsigned int src_flags = src_area->flags;
 	mem_backend_t *src_backend = src_area->backend;
@@ -1048,8 +1061,6 @@
 	 */
 	size_t used_pages = 0;
-	link_t *cur;
-	
-	for (cur = area->used_space.leaf_head.next;
-	    cur != &area->used_space.leaf_head; cur = cur->next) {
+	
+	list_foreach(area->used_space.leaf_list, cur) {
 		btree_node_t *node
 		    = list_get_instance(cur, btree_node_t, leaf_link);
@@ -1077,8 +1088,7 @@
 	size_t frame_idx = 0;
 	
-	for (cur = area->used_space.leaf_head.next;
-	    cur != &area->used_space.leaf_head; cur = cur->next) {
-		btree_node_t *node
-		    = list_get_instance(cur, btree_node_t, leaf_link);
+	list_foreach(area->used_space.leaf_list, cur) {
+		btree_node_t *node = list_get_instance(cur, btree_node_t,
+		    leaf_link);
 		btree_key_t i;
 		
@@ -1088,6 +1098,6 @@
 			
 			for (size = 0; size < (size_t) node->value[i]; size++) {
-				pte_t *pte =
-				    page_mapping_find(as, ptr + (size << PAGE_WIDTH));
+				pte_t *pte = page_mapping_find(as,
+				    ptr + P2SZ(size), false);
 				
 				ASSERT(pte);
@@ -1098,5 +1108,5 @@
 				
 				/* Remove old mapping */
-				page_mapping_remove(as, ptr + (size << PAGE_WIDTH));
+				page_mapping_remove(as, ptr + P2SZ(size));
 			}
 		}
@@ -1110,6 +1120,6 @@
 	
 	/*
-	 * Invalidate potential software translation caches (e.g. TSB on
-	 * sparc64).
+	 * Invalidate potential software translation caches
+	 * (e.g. TSB on sparc64, PHT on ppc32).
 	 */
 	as_invalidate_translation_cache(as, area->base, area->pages);
@@ -1130,6 +1140,5 @@
 	frame_idx = 0;
 	
-	for (cur = area->used_space.leaf_head.next;
-	    cur != &area->used_space.leaf_head; cur = cur->next) {
+	list_foreach(area->used_space.leaf_list, cur) {
 		btree_node_t *node
 		    = list_get_instance(cur, btree_node_t, leaf_link);
@@ -1144,5 +1153,5 @@
 				
 				/* Insert the new mapping */
-				page_mapping_insert(as, ptr + (size << PAGE_WIDTH),
+				page_mapping_insert(as, ptr + P2SZ(size),
 				    old_frame[frame_idx++], page_flags);
 				
@@ -1225,5 +1234,5 @@
 	 */
 	pte_t *pte;
-	if ((pte = page_mapping_find(AS, page))) {
+	if ((pte = page_mapping_find(AS, page, false))) {
 		if (PTE_PRESENT(pte)) {
 			if (((access == PF_ACCESS_READ) && PTE_READABLE(pte)) ||
@@ -1275,5 +1284,5 @@
  * thing which is forbidden in this context is locking the address space.
  *
- * When this function is enetered, no spinlocks may be held.
+ * When this function is entered, no spinlocks may be held.
  *
  * @param old Old address space or NULL.
@@ -1317,5 +1326,5 @@
 			
 			list_append(&old_as->inactive_as_with_asid_link,
-			    &inactive_as_with_asid_head);
+			    &inactive_as_with_asid_list);
 		}
 		
@@ -1466,5 +1475,5 @@
 	
 	if (src_area) {
-		size = src_area->pages << PAGE_WIDTH;
+		size = P2SZ(src_area->pages);
 		mutex_unlock(&src_area->lock);
 	} else
@@ -1521,14 +1530,14 @@
 		if (page >= right_pg) {
 			/* Do nothing. */
-		} else if (overlaps(page, count << PAGE_WIDTH, left_pg,
-		    left_cnt << PAGE_WIDTH)) {
+		} else if (overlaps(page, P2SZ(count), left_pg,
+		    P2SZ(left_cnt))) {
 			/* The interval intersects with the left interval. */
 			return false;
-		} else if (overlaps(page, count << PAGE_WIDTH, right_pg,
-		    right_cnt << PAGE_WIDTH)) {
+		} else if (overlaps(page, P2SZ(count), right_pg,
+		    P2SZ(right_cnt))) {
 			/* The interval intersects with the right interval. */
 			return false;
-		} else if ((page == left_pg + (left_cnt << PAGE_WIDTH)) &&
-		    (page + (count << PAGE_WIDTH) == right_pg)) {
+		} else if ((page == left_pg + P2SZ(left_cnt)) &&
+		    (page + P2SZ(count) == right_pg)) {
 			/*
 			 * The interval can be added by merging the two already
@@ -1538,5 +1547,5 @@
 			btree_remove(&area->used_space, right_pg, leaf);
 			goto success;
-		} else if (page == left_pg + (left_cnt << PAGE_WIDTH)) {
+		} else if (page == left_pg + P2SZ(left_cnt)) {
 			/*
 			 * The interval can be added by simply growing the left
@@ -1545,5 +1554,5 @@
 			node->value[node->keys - 1] += count;
 			goto success;
-		} else if (page + (count << PAGE_WIDTH) == right_pg) {
+		} else if (page + P2SZ(count) == right_pg) {
 			/*
 			 * The interval can be addded by simply moving base of
@@ -1572,9 +1581,8 @@
 		 */
 		
-		if (overlaps(page, count << PAGE_WIDTH, right_pg,
-		    right_cnt << PAGE_WIDTH)) {
+		if (overlaps(page, P2SZ(count), right_pg, P2SZ(right_cnt))) {
 			/* The interval intersects with the right interval. */
 			return false;
-		} else if (page + (count << PAGE_WIDTH) == right_pg) {
+		} else if (page + P2SZ(count) == right_pg) {
 			/*
 			 * The interval can be added by moving the base of the
@@ -1611,14 +1619,14 @@
 		if (page < left_pg) {
 			/* Do nothing. */
-		} else if (overlaps(page, count << PAGE_WIDTH, left_pg,
-		    left_cnt << PAGE_WIDTH)) {
+		} else if (overlaps(page, P2SZ(count), left_pg,
+		    P2SZ(left_cnt))) {
 			/* The interval intersects with the left interval. */
 			return false;
-		} else if (overlaps(page, count << PAGE_WIDTH, right_pg,
-		    right_cnt << PAGE_WIDTH)) {
+		} else if (overlaps(page, P2SZ(count), right_pg,
+		    P2SZ(right_cnt))) {
 			/* The interval intersects with the right interval. */
 			return false;
-		} else if ((page == left_pg + (left_cnt << PAGE_WIDTH)) &&
-		    (page + (count << PAGE_WIDTH) == right_pg)) {
+		} else if ((page == left_pg + P2SZ(left_cnt)) &&
+		    (page + P2SZ(count) == right_pg)) {
 			/*
 			 * The interval can be added by merging the two already
@@ -1628,5 +1636,5 @@
 			btree_remove(&area->used_space, right_pg, node);
 			goto success;
-		} else if (page == left_pg + (left_cnt << PAGE_WIDTH)) {
+		} else if (page == left_pg + P2SZ(left_cnt)) {
 			/*
 			 * The interval can be added by simply growing the left
@@ -1635,5 +1643,5 @@
 			leaf->value[leaf->keys - 1] += count;
 			goto success;
-		} else if (page + (count << PAGE_WIDTH) == right_pg) {
+		} else if (page + P2SZ(count) == right_pg) {
 			/*
 			 * The interval can be addded by simply moving base of
@@ -1662,9 +1670,8 @@
 		 */
 		
-		if (overlaps(page, count << PAGE_WIDTH, left_pg,
-		    left_cnt << PAGE_WIDTH)) {
+		if (overlaps(page, P2SZ(count), left_pg, P2SZ(left_cnt))) {
 			/* The interval intersects with the left interval. */
 			return false;
-		} else if (left_pg + (left_cnt << PAGE_WIDTH) == page) {
+		} else if (left_pg + P2SZ(left_cnt) == page) {
 			/*
 			 * The interval can be added by growing the left
@@ -1701,6 +1708,6 @@
 			 */
 			
-			if (overlaps(page, count << PAGE_WIDTH, left_pg,
-			    left_cnt << PAGE_WIDTH)) {
+			if (overlaps(page, P2SZ(count), left_pg,
+			    P2SZ(left_cnt))) {
 				/*
 				 * The interval intersects with the left
@@ -1708,6 +1715,6 @@
 				 */
 				return false;
-			} else if (overlaps(page, count << PAGE_WIDTH, right_pg,
-			    right_cnt << PAGE_WIDTH)) {
+			} else if (overlaps(page, P2SZ(count), right_pg,
+			    P2SZ(right_cnt))) {
 				/*
 				 * The interval intersects with the right
@@ -1715,6 +1722,6 @@
 				 */
 				return false;
-			} else if ((page == left_pg + (left_cnt << PAGE_WIDTH)) &&
-			    (page + (count << PAGE_WIDTH) == right_pg)) {
+			} else if ((page == left_pg + P2SZ(left_cnt)) &&
+			    (page + P2SZ(count) == right_pg)) {
 				/*
 				 * The interval can be added by merging the two
@@ -1724,5 +1731,5 @@
 				btree_remove(&area->used_space, right_pg, leaf);
 				goto success;
-			} else if (page == left_pg + (left_cnt << PAGE_WIDTH)) {
+			} else if (page == left_pg + P2SZ(left_cnt)) {
 				/*
 				 * The interval can be added by simply growing
@@ -1731,5 +1738,5 @@
 				leaf->value[i - 1] += count;
 				goto success;
-			} else if (page + (count << PAGE_WIDTH) == right_pg) {
+			} else if (page + P2SZ(count) == right_pg) {
 				/*
 				 * The interval can be addded by simply moving
@@ -1797,5 +1804,5 @@
 			for (i = 0; i < leaf->keys; i++) {
 				if (leaf->key[i] == page) {
-					leaf->key[i] += count << PAGE_WIDTH;
+					leaf->key[i] += P2SZ(count);
 					leaf->value[i] -= count;
 					goto success;
@@ -1807,13 +1814,12 @@
 	}
 	
-	btree_node_t *node = btree_leaf_node_left_neighbour(&area->used_space, leaf);
+	btree_node_t *node = btree_leaf_node_left_neighbour(&area->used_space,
+	    leaf);
 	if ((node) && (page < leaf->key[0])) {
 		uintptr_t left_pg = node->key[node->keys - 1];
 		size_t left_cnt = (size_t) node->value[node->keys - 1];
 		
-		if (overlaps(left_pg, left_cnt << PAGE_WIDTH, page,
-		    count << PAGE_WIDTH)) {
-			if (page + (count << PAGE_WIDTH) ==
-			    left_pg + (left_cnt << PAGE_WIDTH)) {
+		if (overlaps(left_pg, P2SZ(left_cnt), page, P2SZ(count))) {
+			if (page + P2SZ(count) == left_pg + P2SZ(left_cnt)) {
 				/*
 				 * The interval is contained in the rightmost
@@ -1824,6 +1830,8 @@
 				node->value[node->keys - 1] -= count;
 				goto success;
-			} else if (page + (count << PAGE_WIDTH) <
-			    left_pg + (left_cnt << PAGE_WIDTH)) {
+			} else if (page + P2SZ(count) <
+			    left_pg + P2SZ(left_cnt)) {
+				size_t new_cnt;
+
 				/*
 				 * The interval is contained in the rightmost
@@ -1833,9 +1841,9 @@
 				 * new interval.
 				 */
-				size_t new_cnt = ((left_pg + (left_cnt << PAGE_WIDTH)) -
-				    (page + (count << PAGE_WIDTH))) >> PAGE_WIDTH;
+				new_cnt = ((left_pg + P2SZ(left_cnt)) -
+				    (page + P2SZ(count))) >> PAGE_WIDTH;
 				node->value[node->keys - 1] -= count + new_cnt;
 				btree_insert(&area->used_space, page +
-				    (count << PAGE_WIDTH), (void *) new_cnt, leaf);
+				    P2SZ(count), (void *) new_cnt, leaf);
 				goto success;
 			}
@@ -1850,8 +1858,6 @@
 		size_t left_cnt = (size_t) leaf->value[leaf->keys - 1];
 		
-		if (overlaps(left_pg, left_cnt << PAGE_WIDTH, page,
-		    count << PAGE_WIDTH)) {
-			if (page + (count << PAGE_WIDTH) ==
-			    left_pg + (left_cnt << PAGE_WIDTH)) {
+		if (overlaps(left_pg, P2SZ(left_cnt), page, P2SZ(count))) {
+			if (page + P2SZ(count) == left_pg + P2SZ(left_cnt)) {
 				/*
 				 * The interval is contained in the rightmost
@@ -1861,6 +1867,8 @@
 				leaf->value[leaf->keys - 1] -= count;
 				goto success;
-			} else if (page + (count << PAGE_WIDTH) < left_pg +
-			    (left_cnt << PAGE_WIDTH)) {
+			} else if (page + P2SZ(count) < left_pg +
+			    P2SZ(left_cnt)) {
+				size_t new_cnt;
+
 				/*
 				 * The interval is contained in the rightmost
@@ -1870,9 +1878,9 @@
 				 * interval.
 				 */
-				size_t new_cnt = ((left_pg + (left_cnt << PAGE_WIDTH)) -
-				    (page + (count << PAGE_WIDTH))) >> PAGE_WIDTH;
+				new_cnt = ((left_pg + P2SZ(left_cnt)) -
+				    (page + P2SZ(count))) >> PAGE_WIDTH;
 				leaf->value[leaf->keys - 1] -= count + new_cnt;
 				btree_insert(&area->used_space, page +
-				    (count << PAGE_WIDTH), (void *) new_cnt, leaf);
+				    P2SZ(count), (void *) new_cnt, leaf);
 				goto success;
 			}
@@ -1896,8 +1904,8 @@
 			 * to (i - 1) and i.
 			 */
-			if (overlaps(left_pg, left_cnt << PAGE_WIDTH, page,
-			    count << PAGE_WIDTH)) {
-				if (page + (count << PAGE_WIDTH) ==
-				    left_pg + (left_cnt << PAGE_WIDTH)) {
+			if (overlaps(left_pg, P2SZ(left_cnt), page,
+			    P2SZ(count))) {
+				if (page + P2SZ(count) ==
+				    left_pg + P2SZ(left_cnt)) {
 					/*
 					 * The interval is contained in the
@@ -1908,6 +1916,8 @@
 					leaf->value[i - 1] -= count;
 					goto success;
-				} else if (page + (count << PAGE_WIDTH) <
-				    left_pg + (left_cnt << PAGE_WIDTH)) {
+				} else if (page + P2SZ(count) <
+				    left_pg + P2SZ(left_cnt)) {
+					size_t new_cnt;
+
 					/*
 					 * The interval is contained in the
@@ -1917,11 +1927,10 @@
 					 * also inserting a new interval.
 					 */
-					size_t new_cnt = ((left_pg +
-					    (left_cnt << PAGE_WIDTH)) -
-					    (page + (count << PAGE_WIDTH))) >>
+					new_cnt = ((left_pg + P2SZ(left_cnt)) -
+					    (page + P2SZ(count))) >>
 					    PAGE_WIDTH;
 					leaf->value[i - 1] -= count + new_cnt;
 					btree_insert(&area->used_space, page +
-					    (count << PAGE_WIDTH), (void *) new_cnt,
+					    P2SZ(count), (void *) new_cnt,
 					    leaf);
 					goto success;
@@ -2010,8 +2019,8 @@
 	
 	/* Eventually check the addresses behind each area */
-	link_t *cur;
-	for (cur = AS->as_area_btree.leaf_head.next;
-	    (ret == 0) && (cur != &AS->as_area_btree.leaf_head);
-	    cur = cur->next) {
+	list_foreach(AS->as_area_btree.leaf_list, cur) {
+		if (ret != 0)
+			break;
+
 		btree_node_t *node =
 		    list_get_instance(cur, btree_node_t, leaf_link);
@@ -2019,10 +2028,11 @@
 		btree_key_t i;
 		for (i = 0; (ret == 0) && (i < node->keys); i++) {
+			uintptr_t addr;
+
 			as_area_t *area = (as_area_t *) node->value[i];
 			
 			mutex_lock(&area->lock);
 			
-			uintptr_t addr =
-			    ALIGN_UP(area->base + (area->pages << PAGE_WIDTH),
+			addr = ALIGN_UP(area->base + P2SZ(area->pages),
 			    PAGE_SIZE);
 			
@@ -2054,8 +2064,6 @@
 	
 	size_t area_cnt = 0;
-	link_t *cur;
-	
-	for (cur = as->as_area_btree.leaf_head.next;
-	    cur != &as->as_area_btree.leaf_head; cur = cur->next) {
+	
+	list_foreach(as->as_area_btree.leaf_list, cur) {
 		btree_node_t *node =
 		    list_get_instance(cur, btree_node_t, leaf_link);
@@ -2070,6 +2078,5 @@
 	size_t area_idx = 0;
 	
-	for (cur = as->as_area_btree.leaf_head.next;
-	    cur != &as->as_area_btree.leaf_head; cur = cur->next) {
+	list_foreach(as->as_area_btree.leaf_list, cur) {
 		btree_node_t *node =
 		    list_get_instance(cur, btree_node_t, leaf_link);
@@ -2083,5 +2090,5 @@
 			
 			info[area_idx].start_addr = area->base;
-			info[area_idx].size = FRAMES2SIZE(area->pages);
+			info[area_idx].size = P2SZ(area->pages);
 			info[area_idx].flags = area->flags;
 			++area_idx;
@@ -2107,7 +2114,5 @@
 	
 	/* Print out info about address space areas */
-	link_t *cur;
-	for (cur = as->as_area_btree.leaf_head.next;
-	    cur != &as->as_area_btree.leaf_head; cur = cur->next) {
+	list_foreach(as->as_area_btree.leaf_list, cur) {
 		btree_node_t *node
 		    = list_get_instance(cur, btree_node_t, leaf_link);
@@ -2121,5 +2126,5 @@
 			    " (%p - %p)\n", area, (void *) area->base,
 			    area->pages, (void *) area->base,
-			    (void *) (area->base + FRAMES2SIZE(area->pages)));
+			    (void *) (area->base + P2SZ(area->pages)));
 			mutex_unlock(&area->lock);
 		}
Index: kernel/generic/src/mm/backend_anon.c
===================================================================
--- kernel/generic/src/mm/backend_anon.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/generic/src/mm/backend_anon.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -39,4 +39,5 @@
 #include <mm/as.h>
 #include <mm/page.h>
+#include <mm/reserve.h>
 #include <genarch/mm/page_pt.h>
 #include <genarch/mm/page_ht.h>
@@ -49,19 +50,95 @@
 #include <typedefs.h>
 #include <align.h>
+#include <memstr.h>
 #include <arch.h>
 
-#ifdef CONFIG_VIRT_IDX_DCACHE
-#include <arch/mm/cache.h>
-#endif
-
-static int anon_page_fault(as_area_t *area, uintptr_t addr, pf_access_t access);
-static void anon_frame_free(as_area_t *area, uintptr_t page, uintptr_t frame);
-static void anon_share(as_area_t *area);
+static bool anon_create(as_area_t *);
+static bool anon_resize(as_area_t *, size_t);
+static void anon_share(as_area_t *);
+static void anon_destroy(as_area_t *);
+
+static int anon_page_fault(as_area_t *, uintptr_t, pf_access_t);
+static void anon_frame_free(as_area_t *, uintptr_t, uintptr_t);
 
 mem_backend_t anon_backend = {
+	.create = anon_create,
+	.resize = anon_resize,
+	.share = anon_share,
+	.destroy = anon_destroy,
+
 	.page_fault = anon_page_fault,
 	.frame_free = anon_frame_free,
-	.share = anon_share
 };
+
+bool anon_create(as_area_t *area)
+{
+	return reserve_try_alloc(area->pages);
+}
+
+bool anon_resize(as_area_t *area, size_t new_pages)
+{
+	if (new_pages > area->pages)
+		return reserve_try_alloc(new_pages - area->pages);
+	else if (new_pages < area->pages)
+		reserve_free(area->pages - new_pages);
+
+	return true;
+}
+
+/** Share the anonymous address space area.
+ *
+ * Sharing of anonymous area is done by duplicating its entire mapping
+ * to the pagemap. Page faults will primarily search for frames there.
+ *
+ * The address space and address space area must be already locked.
+ *
+ * @param area Address space area to be shared.
+ */
+void anon_share(as_area_t *area)
+{
+	ASSERT(mutex_locked(&area->as->lock));
+	ASSERT(mutex_locked(&area->lock));
+
+	/*
+	 * Copy used portions of the area to sh_info's page map.
+	 */
+	mutex_lock(&area->sh_info->lock);
+	list_foreach(area->used_space.leaf_list, cur) {
+		btree_node_t *node;
+		unsigned int i;
+		
+		node = list_get_instance(cur, btree_node_t, leaf_link);
+		for (i = 0; i < node->keys; i++) {
+			uintptr_t base = node->key[i];
+			size_t count = (size_t) node->value[i];
+			unsigned int j;
+			
+			for (j = 0; j < count; j++) {
+				pte_t *pte;
+			
+				page_table_lock(area->as, false);
+				pte = page_mapping_find(area->as,
+				    base + P2SZ(j), false);
+				ASSERT(pte && PTE_VALID(pte) &&
+				    PTE_PRESENT(pte));
+				btree_insert(&area->sh_info->pagemap,
+				    (base + P2SZ(j)) - area->base,
+				    (void *) PTE_GET_FRAME(pte), NULL);
+				page_table_unlock(area->as, false);
+
+				pfn_t pfn = ADDR2PFN(PTE_GET_FRAME(pte));
+				frame_reference_add(pfn);
+			}
+
+		}
+	}
+	mutex_unlock(&area->sh_info->lock);
+}
+
+void anon_destroy(as_area_t *area)
+{
+	reserve_free(area->pages);
+}
+
 
 /** Service a page fault in the anonymous memory address space area.
@@ -115,5 +192,6 @@
 			}
 			if (allocate) {
-				frame = (uintptr_t) frame_alloc(ONE_FRAME, 0);
+				frame = (uintptr_t) frame_alloc_noreserve(
+				    ONE_FRAME, 0);
 				memsetb((void *) PA2KA(frame), FRAME_SIZE, 0);
 				
@@ -145,5 +223,5 @@
 		 *   the different causes
 		 */
-		frame = (uintptr_t) frame_alloc(ONE_FRAME, 0);
+		frame = (uintptr_t) frame_alloc_noreserve(ONE_FRAME, 0);
 		memsetb((void *) PA2KA(frame), FRAME_SIZE, 0);
 	}
@@ -174,58 +252,5 @@
 	ASSERT(mutex_locked(&area->lock));
 
-	frame_free(frame);
-}
-
-/** Share the anonymous address space area.
- *
- * Sharing of anonymous area is done by duplicating its entire mapping
- * to the pagemap. Page faults will primarily search for frames there.
- *
- * The address space and address space area must be already locked.
- *
- * @param area Address space area to be shared.
- */
-void anon_share(as_area_t *area)
-{
-	link_t *cur;
-
-	ASSERT(mutex_locked(&area->as->lock));
-	ASSERT(mutex_locked(&area->lock));
-
-	/*
-	 * Copy used portions of the area to sh_info's page map.
-	 */
-	mutex_lock(&area->sh_info->lock);
-	for (cur = area->used_space.leaf_head.next;
-	    cur != &area->used_space.leaf_head; cur = cur->next) {
-		btree_node_t *node;
-		unsigned int i;
-		
-		node = list_get_instance(cur, btree_node_t, leaf_link);
-		for (i = 0; i < node->keys; i++) {
-			uintptr_t base = node->key[i];
-			size_t count = (size_t) node->value[i];
-			unsigned int j;
-			
-			for (j = 0; j < count; j++) {
-				pte_t *pte;
-			
-				page_table_lock(area->as, false);
-				pte = page_mapping_find(area->as,
-				    base + j * PAGE_SIZE);
-				ASSERT(pte && PTE_VALID(pte) &&
-				    PTE_PRESENT(pte));
-				btree_insert(&area->sh_info->pagemap,
-				    (base + j * PAGE_SIZE) - area->base,
-				    (void *) PTE_GET_FRAME(pte), NULL);
-				page_table_unlock(area->as, false);
-
-				pfn_t pfn = ADDR2PFN(PTE_GET_FRAME(pte));
-				frame_reference_add(pfn);
-			}
-
-		}
-	}
-	mutex_unlock(&area->sh_info->lock);
+	frame_free_noreserve(frame);
 }
 
